// ignore_for_file: non_constant_identifier_names, unused_local_variable, empty_catches

part of galaxeus_lib;

class TcpClient {
  late EventEmitter emitter = EventEmitter();
  late Socket socket;
  late dynamic host;
  late int port;
  late dynamic sourceAddress;
  late int sourcePort = 0;
  late Duration? timeout;
  late bool isConnect = false;
  late Map connect_data = {};
  late Duration ping_interval;
  TcpClient({required this.host, required this.port, this.sourceAddress, this.sourcePort = 0, this.timeout, Map? connectData, EventEmitter? eventEmitter, Duration? pingInterval}) {
    pingInterval ??= Duration(seconds: 1);
    ping_interval = pingInterval;
    if (connectData != null) {
      connect_data.addAll(connect_data);
    }
    if (eventEmitter != null) {
      emitter = eventEmitter;
    }
  }
  Listener on(
    String typeUpdate,
    Function(SocketData update) callback,
  ) {
    return emitter.on(typeUpdate, null, (ev, context) {
      if (ev.eventData is List<int>) {
        SocketData updateSocket = SocketData((ev.eventData as List<int>), type: "");
        callback(updateSocket);
        return;
      }
    });
  }

  Future<void> connect({
    required Function(Socket socket, EventEmitter emitter) onConnect,
    required Function(Object error, EventEmitter emitter) onError,
    required Function(EventEmitter emitter) onDone,
  }) async {
    while (true) {
      await Future.delayed(Duration(milliseconds: 500));
      if (isConnect == false) {
        try {
          socket = await Socket.connect(host, port);
          StreamSubscription<Uint8List> listen = socket.listen(
            (List<int> event) {
              return emitter.emit("update", null, event);
            },
            onError: (a, b) {
              isConnect = false;
            },
            onDone: () async {
              onDone.call(emitter);
              isConnect = false;
              // await socket.done;
              // await socket.close();
              // await connect(
              //   onConnect: onConnect,
              //   onError: onError,
              //   onDone: onDone,
              // );
              Timer.periodic(ping_interval, (timer) async {
                try {
                  await connect(onConnect: onConnect, onError: onError, onDone: onDone);
                } catch (e) {}
                if (isConnect) {
                  timer.cancel();
                }
              });
            },
            cancelOnError: true,
          );
          isConnect = true;
          onConnect.call(socket, emitter);
          break;
        } catch (e) {
          if (e is SocketException) {
            isConnect = false;
          }
          onError.call(e, emitter);
        }
      }
    }
  }

  void emit(
    String typeUpdate,
    List<int> data, {
    String event = "client_send",
  }) {
    return emitter.emit(event, null, data);
  }
}

class SocketData {
  late List<int> raw;
  late String type;
  SocketData(
    this.raw, {
    required this.type,
  });

  String get text {
    late String text = "";
    try {
      text = utf8.decode(raw);
    } catch (e) {}
    return text;
  }

  Map get toJson {
    late Map jsonData = {};
    try {
      jsonData = json.decode(utf8.decode(raw));
    } catch (e) {}
    return jsonData;
  }
}
